{%- import "src/_utils.j2" as utils with context -%}
{%- set dc = ctx|to_context_obj -%}

{%- set global_ns = namespace(description="global in all_questions") -%}
{%- set global_ns.indent = 0 -%}

{%- macro processExpert(global_maps, global_vars, expert) %}
  {% if (global_vars.only_entities_with_annotations and expert.annotations) or not global_vars.only_entities_with_annotations %}
    {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, expert.name, "expert", expert.uuid, none, global_ns.indent, expert.annotations, none) }}
  {%- endif -%}
{%- endmacro -%}

{%- macro processReference(global_maps, global_vars, reference) %}

  {% if (global_vars.only_entities_with_annotations and reference.annotations) or not global_vars.only_entities_with_annotations %}
    {%- if reference is of_type("URLReference") -%}
      {%- set label = reference.label -%}
    {%- elif reference is of_type("ResourcePageReference") -%}
      {%- set label = reference.short_uuid -%}
    {%- else -%}
      {%- set label = reference.target_uuid -%}
    {%- endif -%}
    {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, label, "reference", reference.uuid, none, global_ns.indent, reference.annotations, none) }}
  {% endif %}
{%- endmacro -%}


{%- macro processMetric(global_maps, global_vars, metric) %}
  {% if (global_vars.only_entities_with_annotations and metric.annotations) or not global_vars.only_entities_with_annotations %}
    {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, metric.title, "metric", metric.uuid, dc.pkg.id, global_ns.indent, metric.annotations, none) }}
  {%- endif -%}
{%- endmacro -%}

{%- macro processPhase(global_maps, global_vars, phase) %}
  {% if (global_vars.only_entities_with_annotations and phase.annotations) or not global_vars.only_entities_with_annotations %}
    {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, phase.title, "phase", phase.uuid, dc.pkg.id, global_ns.indent, phase.annotations, none) }}
  {%- endif -%}
{%- endmacro -%}


{%- macro processAnswerValue(global_maps, global_vars, question, reply, path) %}

  {%- if not reply -%}
    {%- set answer = none -%}
  {%- elif reply is of_type("StringReply") -%}
    {%- set answer = reply.value -%}
  {%- else -%}
    {%- set answer = reply.value|markdown  -%}
    {%- if reply.is_integration -%}
      {%- set integration = question.integration -%}
      {%- set answer = integration.item(reply.item_id) -%}
    {%- endif -%}
  {%- endif -%}
  
  {% if (global_vars.only_entities_with_annotations and question.annotations) or not global_vars.only_entities_with_annotations %}
    {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "ValueQuestion", reply.value, path, global_ns.indent, question.annotations, answer)  }}
  {%- endif -%}

{%- endmacro -%}


{%- macro processChoiceList(global_maps, global_vars, question, reply, path) %}

  {% if global_vars.collapsible %}
    {% if (reply and global_vars.only_replies) or global_vars.all_questions or global_vars.all_questions_replies %}
      <details >
        <summary>
          {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "MultiChoiceQuestion", question.uuid, path, global_ns.indent, question.annotations, none)  }}
        </summary>
        <p>
          {% set global_ns.indent = global_ns.indent + 1 %}
          
          {% for choice in question.choices %}
            {%- if reply and choice in reply.choices %}
              {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, choice.label, "choice", choice.uuid, path, global_ns.indent, choice.annotations, choice.label) }}
            {% else %}
              {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, choice.label, "choice", choice.uuid, path, global_ns.indent, choice.annotations, none) }}
            {% endif %}
          {% endfor %}
        
          {% set global_ns.indent = global_ns.indent - 1 %}
        </p>
      </details>
    {% endif %}
  {% else %}
    {% if (reply and global_vars.only_replies) or global_vars.all_questions or global_vars.all_questions_replies or global_vars.only_entities_with_annotations  %}
      {% if (global_vars.only_entities_with_annotations and question.annotations) or not global_vars.only_entities_with_annotations %}
        {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "MultiChoiceQuestion", question.uuid, path, global_ns.indent, question.annotations, none)  }}
      {%- endif -%}

      {% set global_ns.indent = global_ns.indent + 1 %}
          
      {% for choice in question.choices %}
        {% if (global_vars.only_entities_with_annotations and choice.annotations) or not global_vars.only_entities_with_annotations %}
          {%- if reply and choice in reply.choices %}
            {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, choice.label, "choice", choice.uuid, path, global_ns.indent, choice.annotations, choice.label) }}
          {% else %}
            {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, choice.label, "choice", choice.uuid, path, global_ns.indent, choice.annotations, none) }}
          {% endif %}
        {% endif %}
      {% endfor %}
      
      {% set global_ns.indent = global_ns.indent - 1 %}
    {% endif %}
  {% endif %}
{%- endmacro -%}

{%- macro processAnswerOption(global_maps, global_vars, question, reply, path) %}
  {%- if reply -%}
    {%- set answer = reply.answer -%}
  {%- else -%}
    {%- set answer = none  -%}
  {%- endif -%}

  {% if global_vars.collapsible %}
    {% if (reply and global_vars.only_replies) or global_vars.all_questions or global_vars.all_questions_replies %}
      <details >
        <summary>
          {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "OptionsQuestion", question.uuid, path, global_ns.indent, question.annotations, none)  }}
        </summary>
        <p>
          {% set global_ns.indent = global_ns.indent + 1 %}

          {%- for option in question.answers -%}
            {%- set path = path ~ '.' ~ option.uuid -%}
            <details >
              <summary>
                {%- if reply and option.label == answer.label -%}
                  {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, option.label, "answer", answer.uuid, path, global_ns.indent, option.annotations, option.label) }}
                {% else %}
                  {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, option.label, "answer", answer.uuid, path, global_ns.indent, option.annotations, none) }}
                {% endif %}
              </summary>
              <p>
                {%- for question in option.followups -%}
                  {{ processQuestion(global_maps, global_vars, question, path) }}
                {%- endfor -%}
              </p>
            </details>
          {% endfor %}

        {% set global_ns.indent = global_ns.indent - 1 %}
        </p>
      </details>
    {% endif %}
  {% else %}
    {% if (reply and only_replies) or global_vars.all_questions or global_vars.all_questions_replies or global_vars.only_entities_with_annotations %}
      {% if (global_vars.only_entities_with_annotations and question.annotations) or not global_vars.only_entities_with_annotations %}
        {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "OptionsQuestion", question.uuid, path, global_ns.indent, question.annotations, none)  }}
      {% endif %}
      {% set global_ns.indent = global_ns.indent + 1 %}

      {%- for option in question.answers -%}
        {%- set path = path ~ '.' ~ option.uuid -%}
        {% if (global_vars.only_entities_with_annotations and option.annotations) or not global_vars.only_entities_with_annotations %}
          {%- if reply and option.label == answer.label -%}
            {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, option.label, "answer", answer.uuid, path, global_ns.indent, option.annotations, option.label) }}
          {% else %}
            {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, option.label, "answer", answer.uuid, path, global_ns.indent, option.annotations, none) }}
          {% endif %}
        {% endif %}
        {%- for question in option.followups -%}
          {{ processQuestion(global_maps, global_vars, question, path) }}
        {%- endfor -%}
      {% endfor %}

      {% set global_ns.indent = global_ns.indent - 1 %}
    {% endif %}
  {% endif %}
{%- endmacro -%}

{%- macro processAnswerList(global_maps, global_vars, question, reply, path) %}

  {% if global_vars.collapsible %}
    {% if (reply and global_vars.only_replies) or global_vars.all_questions or global_vars.all_questions_replies %}
      <details>
        <summary>
          {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "ListQuestion", question.uuid, path, global_ns.indent, question.annotations, none)  }}
        </summary>
        <p>
          {% if not reply  %}
            {%- for question in question.followups -%}           
              {{ processQuestion(global_maps, global_vars, question, path) }}        
            {%- endfor -%}
          {% else %}
            {%- for item in reply.items -%}
              {%- set itemPathPrefix = path ~ '.' -%}
              {%- set itemPath = itemPathPrefix ~ item -%}
              {%- for q in question.followups -%}           
                {{ processQuestion(global_maps, global_vars, q, itemPath) }}        
              {%- endfor -%}    
            {%- endfor -%}
          {% endif %}
        </p>
      </details>
    {% endif %}
  {% else %}
    {% if (reply and global_vars.only_replies) or global_vars.all_questions or global_vars.all_questions_replies or global_vars.only_entities_with_annotations %}
      {% if (global_vars.only_entities_with_annotations and question.annotations) or not global_vars.only_entities_with_annotations %}
        {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "ListQuestion", question.uuid, path, global_ns.indent, question.annotations, none)  }}
      {% endif %}
      {% if not reply  %}
        {%- for question in question.followups -%}           
          {{ processQuestion(global_maps, global_vars, question, path) }}        
        {%- endfor -%}
      {% else %}
        {%- for item in reply.items -%}
          {%- set itemPathPrefix = path ~ '.' -%}
          {%- set itemPath = itemPathPrefix ~ item -%}
          {%- for q in question.followups -%}           
            {{ processQuestion(global_maps, global_vars, q, itemPath) }}        
          {%- endfor -%}    
        {%- endfor -%}
      {% endif %}
    {% endif %}
  {% endif %}
{%- endmacro -%}

{%- macro renderAnswerItemSelect(global_maps, global_vars, question, reply, path) %}

  {%- if not reply -%}
    {%- set answer = none -%}
  {%- else -%}
    {%- set answer = reply.item_title %}
    {#    "<a href=\"#item-" ~ question.list_question_uuid ~ "-" ~ reply.item_uuid ~ "\"" ~ ">" ~ reply.item_title ~ "</a>" %} #}
  {%- endif -%}
  
  {% if (global_vars.only_entities_with_annotations and question.annotations) or
    not global_vars.only_entities_with_annotations %}
    {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, question.title, "ItemSelectQuestion", reply.value, path, global_ns.indent, question.annotations, answer)  }}
  {%- endif -%}

  {#  <a href="#item-{{ question.list_question_uuid }}-{{ reply.item_uuid }}">{{ reply.item_title }}</a> #}

{%- endmacro -%}

{%- macro processQuestionReply(global_maps, global_vars, question, path) %}
  {%- set reply = question.replies.get(path) -%}    
  {%- for expert in question.experts -%}
    {{ processExpert(global_maps, global_vars, expert) }}
  {%- endfor %}
  {%- for reference in question.references -%}
    {{ processReference(global_maps, global_vars, reference) }}
  {%- endfor %}

  {% if global_vars.only_entities_with_annotations or global_vars.all_questions %}
    {% set reply = none %}
  {% endif %}

  {%- if reply and reply.value -%}
    {%- if question is of_type('ValueQuestion') or question is of_type("IntegrationQuestion") -%}
      {{ processAnswerValue(global_maps, global_vars, question, reply, path) }}        
    {%- elif question is of_type('OptionsQuestion') and reply is of_type('AnswerReply') -%}
      {{ processAnswerOption(global_maps, global_vars, question, reply, path) }}        
    {%- elif question is of_type('ListQuestion') and reply is of_type('ItemListReply') -%}
      {{ processAnswerList(global_maps, global_vars, question, reply, path) }}        
    {% elif question is of_type("MultiChoiceQuestion") and reply is of_type("MultiChoiceReply") %}
      {{ processChoiceList(global_maps, global_vars, question, reply, path) }}
    {% elif question is of_type("ItemSelectQuestion") and reply is of_type("ItemSelectReply") %}
      {{ renderAnswerItemSelect(global_maps, global_vars, question, reply, path) }}
    {%- endif -%}
  {% elif (not global_vars.only_replies) or global_vars.only_entities_with_annotations or global_vars.all_questions or global_vars.all_questions_replies %}  {# no replies here #}
    {%- if question is of_type('ValueQuestion') or question is of_type("IntegrationQuestion")-%}
      {{ processAnswerValue(global_maps, global_vars, question, none, path) }}        
    {%- elif question is of_type('OptionsQuestion') -%}
      {{ processAnswerOption(global_maps, global_vars, question, none, path) }}        
    {%- elif question is of_type('ListQuestion') -%}
      {{ processAnswerList(global_maps, global_vars, question, none, path) }}        
    {%- elif question is of_type('MultiChoiceQuestion') -%}
      {{ processChoiceList(global_maps, global_vars, question, none, path) }}
    {% elif question is of_type("ItemSelectQuestion") %}
      {{ renderAnswerItemSelect(global_maps, global_vars, question, none, path) }}
    {%- endif -%}
  {% endif %}
{%- endmacro -%}

{%- macro processQuestion(global_maps, global_vars, question, path) %}
  {%- set path = path ~ '.' ~ question.uuid -%}

  {% set global_ns.indent = global_ns.indent + 1 %}
  {{ processQuestionReply(global_maps, global_vars, question, path) }}
  {% set global_ns.indent = global_ns.indent - 1 %}
  
{%- endmacro -%}


{%- macro processChapter(global_maps, global_vars, chapter) %}

  {% if global_vars.collapsible %}
    <details >
      <summary>
        {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, chapter.title, "chapter", chapter.uuid, dc.pkg.id, global_ns.indent, chapter.annotations, none) }}
      </summary>
      <p>
        {%- for question in chapter.questions -%} 
          {{ processQuestion(global_maps, global_vars, question, chapter.uuid) }}
        {%- endfor -%}
      </p>
    </details>
  {% else %}
    {% if (global_vars.only_entities_with_annotations and chapter.annotations) or not global_vars.only_entities_with_annotations %}
      {{ utils.displayEntityAnnotationWithMapping(global_maps, global_vars, chapter.title, "chapter", chapter.uuid, dc.pkg.id, global_ns.indent, chapter.annotations, none) }}
    {% endif %}
    {%- for question in chapter.questions -%} 
      {{ processQuestion(global_maps, global_vars, question, chapter.uuid) }}
    {%- endfor -%}
  {% endif %}

{%- endmacro -%}


